import { Injectable, Optional } from '@angular/core';
import { User } from '../models/user.model';
import { LogService } from './log.service';
import { HttpClient } from '@angular/common/http';
import { Observable, throwError } from 'rxjs';
import { map, catchError } from 'rxjs/operators';

@Injectable()

export class UsersService {

  constructor(@Optional() private logService: LogService, private http: HttpClient) { }

  private users: User[] = [
    new User("Ben",25, 'test@test.com','pass'),
    new User("John",35, 'test@test.com','pass'),
    new User("Bob",45, 'test@test.com','pass'),
  ];


  getUsers() : Observable<User[]> {
    if(this.logService) {
      this.logService.write("Get users array");
    }
    return this.http.get<User[]>('http://ang.loc/api/users').pipe(
      map((data)=>{
        return data['users']
      }),
      catchError((error)=>{

        console.log('Error', error);
        return throwError(error)
      })
    );
    
  }

  getUser(nmb: number): User {
    return this.users[nmb];
  }

  

   
}
